#ifndef AXISALIGNEDBOUNDINGBOX_H
#define AXISALIGNEDBOUNDINGBOX_H

/**
 * AxisAlignedBoundingBox.h: a simple AABB
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "util/Vector3D.h"
using util::Vector3D;


namespace blurt
{

class Ray;

class AxisAlignedBoundingBox
{
	public:
		AxisAlignedBoundingBox() {};
		AxisAlignedBoundingBox(const Vector3D& p1, const Vector3D& p2);
		~AxisAlignedBoundingBox();

		bool intersectsRay(const Ray& r, float* distance) const;
		bool contains(const Vector3D& point) const;

		/// Returns the length of the longest edge
		float getLongestEdge() const;

		Vector3D pos1;
		Vector3D pos2;
};

};

#endif // AXISALIGNEDBOUNDINGBOX_H
