/**
 * IntersectionInformation.cpp
 *
 * (c) 2007, 2008 Thomas Unterthiner
 *
 */

#include "IntersectionInformation.h"
#include "TraceableObject.h"
#include "Ray.h"

namespace blurt
{

IntersectionInformation::IntersectionInformation(const IntersectionData& id,
                                                 const Ray& ray)
	: IntersectionData(id)
{
	calculateIntersection(ray);
}


void IntersectionInformation::calculateIntersection(const Ray& ray)
{
	intersectionPoint = ray.getOrigin() + distance * ray.getDirection();
	intersectionNormal = hitObject->getNormal(intersectionPoint);

	// if we hit a triangle, the normal should always face the
	// origin of the ray
	if (hitObject->getType() == TraceableObject::TRIANGLE
		|| hitObject->getType() == TraceableObject::PLANE)
	{
//		float dot = dotProduct(intersectionNormal, ray.getOrigin());
		float dot = dotProduct(intersectionNormal, ray.getDirection());
		if (dot > 0.0f)
			intersectionNormal *= -1;
	}
}

}
