#ifndef INTERSECTIONINFORMATION_H
#define INTERSECTIONINFORMATION_H
/**
 * IntersectionInformation.h
 *
 * (c) 2007, 2008 Thomas Unterthiner
 *
 */

#include "util/Vector3D.h"
#include "IntersectionData.h"


namespace blurt
{
class Ray;
class TraceableObject;


/**
 * IntersectionInformation
 * This is a private class that is used inside the Raytracer to pass
 * the IntersectionData all in one Datastructure :)
 */
class IntersectionInformation : public IntersectionData
{
	public:
		IntersectionInformation(const IntersectionData& id, const Ray& ray);
		const Vector3D& getIntersectionPoint() const {return intersectionPoint;}
		const Vector3D& getIntersectionNormal() const {return intersectionNormal;}


	private:
		void calculateIntersection(const Ray& ray);
		Vector3D intersectionPoint;
		Vector3D intersectionNormal;
};

}

#endif // EXTENDEDINTERSECTIONDATA_H
