/**
 * Material.cpp
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "Material.h"
#include <iostream>

using namespace std;
using namespace blurt;


blurt::Material::Material()
	:c(0, 0, 0), diffuse(0.2), specular(0.8),
	 phongConstant(20), reflective(0), refractive(0),
	 refractionIndex(1.5), density(0.15)
{}

blurt::Material::Material(const Color& col, float dif, float spec, float phongC,
	               float refl, float refr, float refrIndex, float dens)
	:c(col), diffuse(dif), specular(spec),
	 phongConstant(phongC), reflective(refl), refractive(refr),
	 refractionIndex(refrIndex), density(dens)
{}


blurt::Material::~Material()
{
	//dtor
}

std::ostream& blurt::operator<< (std::ostream& stream, const Material& m)
{
	stream << "MATERIAL("
		<< "Color: " << m.getColor()
		<< "\tDiffuse: " << m.getDiffuse()
		<< "\tSpecular: " << m.getSpecular()
		<< "\tPhong: " << m.getPhongConstant()
		<< "\tReflective: " << m.getReflective()
		<< "\tRefractive: " << m.getRefractive()
		<< "\tRefractionIndex: " << m.getRefractionIndex()
		<< "\tDensity: " << m.getDensity() << ')';
	return stream;
}

std::istream& blurt::operator>> (std::istream& stream, Material& m)
{
	stream.ignore(16);
	stream >> m.c;
	stream.ignore(9);
	stream >> m.diffuse;
	stream.ignore(10);
	stream >> m.specular;
	stream.ignore(7);
	stream >> m.phongConstant;
	stream.ignore(12);
	stream >> m.reflective;
	stream.ignore(12);
	stream >> m.refractive;
	stream.ignore(17);
	stream >> m.refractionIndex;
	stream.ignore(9);
	stream >> m.density;
	stream.ignore();
	return stream;
}
