#ifndef PLANE_H
#define PLANE_H

#include "TraceableObject.h"

namespace blurt
{

class Plane : public TraceableObject
{
	public:
		Plane(const char* name, const Material& material,
			const Vector3D& normal, float d);
		Plane(std::istream& is);
		virtual ~Plane();
		const Vector3D& getNormal() const {return normal;}
		float getD() const {return d;}

	private:
		virtual bool intersectsRayImpl(const Ray& ray, float* distance) const;
		virtual void intersectRayPacketImpl(RayPacket* rayPacket) const;
		virtual Vector3D getNormalImpl(const Vector3D& pos) const;
		virtual AxisAlignedBoundingBox getAxisAlignedBoundingBoxImpl() const;
		virtual bool intersectsBoxImpl(const Vector3D& lower, const Vector3D& higher) const;
		virtual Type getTypeImpl() const {return PLANE;}

		virtual void readFromFile(std::istream& is);
		virtual void writeToFile(std::ostream& os) const;

		Vector3D normal;
		float d;
};

};

#endif // PLANE_H
