#ifndef RAY_H
#define RAY_H

/**
 * Ray.h: a Ray
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "util/Vector3D.h"

namespace blurt
{

using util::Vector3D;
class TraceableObject;

class Ray
{
	public:
		Ray() {};
		Ray(const Vector3D& origin, const Vector3D& direction);
		Ray& operator=(const Ray& rhs);

		const Vector3D& getOrigin() const { return origin;}
		const Vector3D& getDirection() const {return direction;}

		void setOrigin(const Vector3D& newOrigin) {origin = newOrigin;}

		static unsigned getRayCount() {return rayCount;}
		static void resetRayCount() {rayCount = 0;}

	private:
		static unsigned rayCount;
		friend class RayPacket;

		Vector3D origin;
		Vector3D direction;
};


inline Ray::Ray(const Vector3D& origin_, const Vector3D& direction_)
	: origin(origin_),
	  direction(direction_)
{
	++rayCount;
}


};

#endif // RAY_H
