#ifndef SPATIALSUBDIVISION_H
#define SPATIALSUBDIVISION_H


/**
 * SpatialSubdivision.h
 *
 * (c) 2007 Thomas Unterthiner
 *
 */


#define USE_KDTREE 0
#define USE_GRID 0


#if USE_KDTREE
	#include "KdTree.h"
	#include "KdTreeHelper.h"
#elif USE_GRID
	#include "RegularGrid.h"
#else
	#include "NoSpatialSubdivision.h"
#endif

namespace blurt
{
#if USE_KDTREE
//	typedef KdTree<kdtree::SpatialMedianSplitter> SpatialSubdivision;
	typedef KdTree<kdtree::SahSplitter> SpatialSubdivision;
#elif USE_GRID
	typedef RegularGrid SpatialSubdivision;
#else
	typedef NoSpatialSubdivision SpatialSubdivision;
#endif
};




#endif
