#include "Engine.h"
#include "blurt/EngineError.h"
#include <cstdio>


/**
 * main.cpp: the startup-code for blueRT
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

using namespace std;

#include "util/Vector3D.h"
#include "util/sse_helper.h"
using namespace util;
using namespace util::sse;

int main ( int argc, char** argv )
{
/*
	Vector3D v3[4];
	for (int i = 0; i < 4; ++i)
	{
		v3[i] = Vector3D(3.f*i, 3.f*i + 1, 3.f*i + 2);
		cout << v3[i] << endl;
	}
	cout << endl;

	VectorArraySSE vSSE (v3, 4);

	for (int i = 0; i < 3; ++i)
	{
		cout << vSSE[i] << endl;
	}
	cout << endl;


	VectorArray3D v3b = convertToVector3D(vSSE);

	for (int i = 0; i < 4; ++i)
	{
		cout << v3b[i] << endl;
	}

*/
	try
	{
		Engine::get().run(argc, argv);
	}
	catch (blurt::EngineError error)
	{
		// we use printf instead of iostream to save some KB
		// (iostream is a large library when linked statically ;) )
		if (!error.getDetails().empty())
			printf("%s\n\tDetails: %s", error.what(), error.getDetails().c_str());
		else
			printf("%s\n", error.what());
	}

    return 0;
}
