/**
 * Framework_sdl.cpp:
 *	SDL-centric implementation of the framework.
 *
 * (c) 2007 Thomas Unterthiner
 *
 */


#include "Framework.h"
#include "blurt/EngineError.h"
#include "Color.h"
#include <cstdlib>
#include <csignal>

using blurt::EngineError;

namespace platform
{
	time_t startTime;
	bool doRun;

	void handleSIGINT(int sig)
	{
		doRun = false;
	}


/**
 * Intializes the framework.
 */
void init()
{
	startTime = time(0);
	doRun = true;
	(void) signal(SIGINT, handleSIGINT);
	(void) signal(SIGTERM, handleSIGINT);
}


/**
 * Returns some kind of time measurement.
 */
unsigned int  getTicks()
{
	return (unsigned int) (difftime(time(0), startTime) * 1000);
}


/**
 * Deals with all kind of input.
 */
bool handleInput()
{
	// doRun will get updated when a SIGINT is raised
	return doRun;
}


void sleep(unsigned int milliseconds)
{
	// TODO: implement this plattformindependent ?-)
}

struct Screen::ScreenImpl
{
	int width;
	int height;
};

Screen::Screen(int screenWidth, int screenHeight, const char* windowTitle)
	: d(new ScreenImpl())
{
	d->width = screenWidth;
	d->height = screenHeight;
}



Screen::~Screen()
{
	delete d;
}


void Screen::draw(const Color* image)
{
}


void Screen::save(const char* path)
{
	throw EngineError("Screenshots are not implemented in the headless version");
}


int Screen::getWidth() const
{
	return d->width;
}


int Screen::getHeight() const
{
	return d->height;
}

void Screen::update() const
{
};


void shutdown(framework::Screen& s)
{
}
};



