/**
 * Clock.cpp: implementation of Clock.h
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "Clock.h"
#include "platform/Framework.h"


/* not needed right now ;)
const int Clock::LOGICFRAMES_PER_SECOND = 20;
const int TICKTIME = 1000/Clock::LOGICFRAMES_PER_SECOND;
*/

Clock::Clock()
	:  frameCount(0), frameIdx(0)
{}


Time Clock::getTicks() const
{
	return platform::getTicks();
}


Time Clock::getFrametime() const
{
	size_t idx = frameIdx - 1;
	if (frameIdx <= 0) idx = FPS_FRAMES - 1;
	return frames[idx];
}


void Clock::startFrame()
{
	Time now = getTicks();
	frameStart = now;
}


void Clock::endFrame()
{
	Time now = getTicks();
	frames[frameIdx++] = now - frameStart;
	if (frameIdx >= FPS_FRAMES)
		frameIdx -= FPS_FRAMES;
	++frameCount;
}



float Clock::getFps() const
{
	unsigned int sum = 0;
	for (size_t i = 0; i < FPS_FRAMES; ++i)
		sum += frames[i];

	return 1000.f / (static_cast<float>(sum) / FPS_FRAMES);
}


