#ifndef CMDLINEPARSER_H
#define CMDLINEPARSER_H

#include <string>

namespace util
{

class CmdLineParser
{
	public:
		CmdLineParser();
		~CmdLineParser();

		bool parse(int argc, char** argv);

		std::string getArgument(const std::string& option);
		void getArgument(const std::string& option, int* arg);
		bool isOptionPresent(const std::string& option);

	private:
		bool parseImpl(int argc, char** argv);

		// we hide the implementation so we don't have to
		// include the boost-libraries :)
		struct CmdLineParserImpl;
		CmdLineParserImpl* d;
};

};

#endif // CMDLINEPARSER_H
