#ifndef THEORAENCODER_H
#define THEORAENCODER_H

/**
 * TheoraEncoder.h: a simple theora encoder.
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "util/Color.h"
#include <string>
#include <fstream>

namespace util
{

using util::Color;

class TheoraEncoder
{
	public:
		TheoraEncoder(const std::string& outputfile,int width, int height, int fps);
		~TheoraEncoder();

		/**
		 * Adds a new frame.
		 * The YUV-Data must be passed already in IYUV-Format
		 */
		void addFrame(int width, int height, Color* image,
		              bool isLastFrame = false);

	private:
		class TheoraEncoderImpl;
		TheoraEncoderImpl* d;
};

};


#endif // THEORAENCODER_H
